if (!window.zwexplorer) {
    /** 默认IP */
    let host = 'http://127.0.0.1'
        /** 默认端口号 */
    let port = '56289'
        /** 是否初始化完成 */
    let initialized = false
        /** 默认请求头 */
    const headers = {
            'Content-Type': 'application/json;charset=UTF-8'
        }
        /** 发送http post的请求 */
    const httpPost = async(url, data) => {
        return new Promise((resolve, reject) => {
            // 1. 创建 xhr 对象
            const xhr = new XMLHttpRequest()
                // 2. 调用 open 函数
            xhr.open('POST', `${host}:${port}${url}`)
                // 3. 设置 Content-Type 属性（固定写法）
            for (const key in headers) {
                xhr.setRequestHeader(key, headers[key])
            }
            // 4. 调用 send 函数
            xhr.send(JSON.stringify(data))
                // 5. 监听事件
            xhr.onreadystatechange = function() {
                if (xhr.readyState === 4 && xhr.status === 200) {
                    resolve(JSON.parse(xhr.responseText))
                }
                if (xhr.readyState === 4 && xhr.status !== 200) {
                    reject()
                }
            }
        })
    }

    const zwexplorer = {
        /** 初始化zwexplorer方法 */
        __init: async(params = {}, callback = () => {}) => {
            if (params.host) host = params.host;
            if (!host.toLowerCase().startsWith("http")) {
                host = "http://" + host;
            }
            if (params.port) port = params.port
                /** @plugins 已安装的插件对象 */
            httpPost('/__zwexplorerInit').then(plugins => {
                for (const appName in plugins) {
                    zwexplorer[appName] = {};
                    if (Array.isArray(plugins[appName].trigger)) {

                        for (const trigger of plugins[appName].trigger) {
                            zwexplorer[appName][trigger] = async(reqBody = '', cb = () => {}) => {
                                return httpPost(`/${appName}/${trigger}`, reqBody).then(resBody => {
                                    cb(resBody)
                                    return resBody
                                })
                            }
                        }
                    } else {

                        //类似国密这样的情况，trigger是一个对象
                        const triggerKeys = Object.keys(plugins[appName].trigger);

                        for (const key of triggerKeys) {
                            // alert(key);
                            zwexplorer[appName][key] = {};
                            const childTriggers = plugins[appName].trigger[key];
                            for (const childTrigger of childTriggers) {

                                zwexplorer[appName][key][childTrigger] = async(reqBody = '', cb = () => {}) => {
                                    return httpPost(`/${appName}/${key}/${childTrigger}`, reqBody).then(resBody => {
                                        cb(resBody)
                                        return resBody
                                    })
                                }


                            }
                        }
                        console.log(zwexplorer);

                    }
                }
                initialized = true
                callback({ resultCode: 0, resultMessage: '初始化成功', data: plugins })
            }).catch(err => {
                callback({ resultCode: -1, resultMessage: '初始化失败：检测到你再第三方浏览器中使用政务浏览器的能力，请检查政务浏览器的API Http Server是否启动，端口是否正确！', data: {} })
            })
        },
    }

    window.zwexplorer = zwexplorer
}